'DisplayElapsedTime.csc
'Copyright 2003 by Abe Hendin <venturadev@yourspeed.com>. Public Domain.
'Version 1.01
'September 30, 2003

'This script is not for standalone usage. See the comments interspersed
'for details of how it works, and incorporate its parts into your existing
'scripts as needed.

'Version 1.01: Initial release (May 18, 2003) did not handle more than ~9 hours 
'correctly. The SUB now displays up to 99:59:59.999, and indicates when elapsed time
'exceeds this value (>4 days, 3:59:59.99).


#ADDFOL "C:\Program Files\Corel\Ventura 10\Scripts"
#INCLUDE "ScpConst.csi"
#DEFINE APP_NAME			"Display Elapsed Time"

'GLOBAL VARIABLE DEFINITIONS
GLOBAL lStartTime AS LONG, lEndTime AS LONG, iret AS INTEGER

'DECLARATIONS: (function courtesy of Gabor Deak Jahn)
DECLARE FUNCTION GetTickCount LIB "Kernel32" AS LONG ALIAS "GetTickCount"
DECLARE SUB DisplayElapsedTime


'get starting time
lStartTime = GetTickCount()


'[PUT SCRIPT PROCESSING TO BE TIMED HERE...]


'get ending time
lEndTime = GetTickCount()

'display elapsed time in human-readable format
CALL DisplayElapsedTime


'put this sub anywhere after its declaration
SUB DisplayElapsedTime 'PUBLIC DOMAIN.
	'Written by Abe Hendin <venturadev@yourspeed.com>
	'Version 1.01, October 12, 2003
	'SUB expects to receive values for "lStartTime" and "lEndTime".
	'Displays up to 99:59:59.999 (4 days + 03:59:59.999); if more than this, 
	'displays "> 99:59:59.999".
	
	DIM iret AS INTEGER
	DIM lElapsedMilliseconds AS LONG
	DIM dSecondsTotal AS DOUBLE, dHoursTotal AS DOUBLE, dMinutesTotal AS DOUBLE
	DIM iHours AS INTEGER, iSeconds AS INTEGER
	DIM iMinutes AS INTEGER, iMilliseconds AS INTEGER
	DIM sHoursDisplay AS STRING, sMinutesDisplay AS STRING
	DIM sSecondsDisplay AS STRING, sMillisecondsDisplay AS STRING
	DIM sDisplayElapsed AS STRING

	lElapsedMilliseconds = lEndTime - lStartTime
	dSecondsTotal = lElapsedMilliseconds/1000
	
	iHours = FIX(dSecondsTotal/3600) 'round down to nearest whole integer
	iMinutes = FIX((dSecondsTotal/3600 - iHours)*60)
	iSeconds = FIX((dSecondsTotal/60 - iHours*60 - iMinutes)*60)
	iMilliseconds = FIX(CDBL(lElapsedMilliseconds) - CDBL(iHours*3600*1000) - \\
		CDBL(iMinutes*60*1000) - CDBL(iSeconds*1000))

	sHoursDisplay = RIGHT("00" + LTRIM(STR(iHours)), 2)
	sMinutesDisplay = RIGHT("00" + LTRIM(STR(iMinutes)), 2)
	sSecondsDisplay = RIGHT("00" + LTRIM(STR(iSeconds)), 2)
	sMillisecondsDisplay = RIGHT("000" + LTRIM(STR(iMilliseconds)), 3)
	
	sDisplayElapsed = sHoursDisplay & ":" & sMinutesDisplay & ":" & \\
		sSecondsDisplay & "." & sMillisecondsDisplay
	
	IF iHours <= 99 THEN
		iret = MESSAGEBOX("Elapsed time: " + sDisplayElapsed + " (hh:mm:ss.mss)     ", \\
			APP_NAME, MB_OK_ONLY + MB_INFORMATION_ICON)
	ELSE 'more than 99:59:59.999 has elapsed (4 days + 03:59:59.999)
		iret = MESSAGEBOX("Elapsed time: > 99:59:59.999 (hh:mm:ss.mss)     ", \\
			APP_NAME, MB_OK_ONLY + MB_INFORMATION_ICON)
	ENDIF
END SUB

